diff -rN -u old-darcsweb/darcsweb.cgi new-darcsweb/darcsweb.cgi
--- old-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
+++ new-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
@@ -1214,48 +1354,59 @@
     <a href="%(myrname)s;a=commit;h=%(hash)s">commit</a> |
     <a href="%(myrname)s;a=commitdiff;h=%(hash)s">commitdiff</a>
   </td>
-		""" % {
-			'age': how_old(p.local_date),
-			'author': gen_authorlink(p.author, shorten_str(p.shortauthor, 26)),
-			'myrname': config.myreponame,
-			'hash': p.hash,
-			'name': escape(shorten_str(p.name)),
-			'fullname': escape(p.name),
-		}
-		print "</tr>"
-
-	if len(ps) >= last:
-		# only show if we've not shown them all already
-		print '<tr><td>'
-		if fname:
-			print '<a href="%s;a=filehistory;topi=%d;f=%s">...</a>' \
-				% (config.myreponame, topi + last, fname)
-		else:
-			print '<a href="%s;a=shortlog;topi=%d">...</a>' \
-				% (config.myreponame, topi + last)
-		print '</td></tr>'
-	print "</table>"
-
-
-def print_log(last = PATCHES_PER_PAGE, topi = 0):
-	ps = get_last_patches(last, topi)
-
-	if topi != 0:
-		# put a link to the previous page
-		ntopi = topi - last
-		if ntopi < 0:
-			ntopi = 0
-		print '<p/><a href="%s;a=log;topi=%d">&lt;- Prev</a><p/>' % \
-				(config.myreponame, ntopi)
-
-	for p in ps:
-		if p.comment:
-			comment = replace_links(escape(p.comment))
-			fmt_comment = comment.replace('\n', '<br/>') + '\n'
-			fmt_comment += '<br/><br/>'
-		else:
-			fmt_comment = ''
-		print """
+		"""
+            % {
+                "age": how_old(p.local_date),
+                "author": gen_authorlink(
+                    p.author, shorten_str(p.shortauthor, 26)
+                ),
+                "myrname": config.myreponame,
+                "hash": p.hash,
+                "name": xmlescape(shorten_str(p.name)),
+                "fullname": xmlescape(p.name),
+            }
+        )
+        print("</tr>")
+
+    if len(ps) >= last:
+        # only show if we've not shown them all already
+        print("<tr><td>")
+        if fname:
+            print(
+                '<a href="%s;a=filehistory;topi=%d;f=%s">...</a>'
+                % (config.myreponame, topi + last, fname)
+            )
+        else:
+            print(
+                '<a href="%s;a=shortlog;topi=%d">...</a>'
+                % (config.myreponame, topi + last)
+            )
+        print("</td></tr>")
+    print("</table>")
+
+
+def print_log(last=PATCHES_PER_PAGE, topi=0):
+    ps = get_last_patches(last, topi)
+
+    if topi != 0:
+        # put a link to the previous page
+        ntopi = topi - last
+        if ntopi < 0:
+            ntopi = 0
+        print(
+            '<p/><a href="%s;a=log;topi=%d">&lt;- Prev</a><p/>'
+            % (config.myreponame, ntopi)
+        )
+
+    for p in ps:
+        if p.comment:
+            comment = replace_links(xmlescape(p.comment))
+            fmt_comment = comment.replace("\n", "<br/>") + "\n"
+            fmt_comment += "<br/><br/>"
+        else:
+            fmt_comment = ""
+        print(
+            """
 <div><a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">
     <span class="age">%(age)s</span>%(desc)s
 </a></div>
@@ -1270,452 +1421,493 @@
   %(comment)s
 </div>
 
-		""" % {
-			'myreponame': config.myreponame,
-			'age': how_old(p.local_date),
-			'date': p.local_date_str,
-			'author': gen_authorlink(p.author, p.shortauthor),
-			'hash': p.hash,
-			'desc': escape(p.name),
-			'comment': fmt_comment
-		}
-
-	if len(ps) >= last:
-		# only show if we've not shown them all already
-		print '<p><a href="%s;a=log;topi=%d">Next -&gt;</a></p>' % \
-				(config.myreponame, topi + last)
+		"""
+            % {
+                "myreponame": config.myreponame,
+                "age": how_old(p.local_date),
+                "date": p.local_date_str,
+                "author": gen_authorlink(p.author, p.shortauthor),
+                "hash": p.hash,
+                "desc": xmlescape(p.name),
+                "comment": fmt_comment,
+            }
+        )
+
+    if len(ps) >= last:
+        # only show if we've not shown them all already
+        print(
+            '<p><a href="%s;a=log;topi=%d">Next -&gt;</a></p>'
+            % (config.myreponame, topi + last)
+        )
 
 
 def print_blob(fname):
-	print '<div class="page_path"><b>%s</b></div>' % escape(fname)
-	if isbinary(fname):
-		print """
+    print('<div class="page_path"><b>%s</b></div>' % xmlescape(fname))
+    if isbinary(fname):
+        print(
+            """
 <div class="page_body">
 <i>This is a binary file and its contents will not be displayed.</i>
 </div>
 		"""
-		return
+        )
+        return
+
+    try:
+        import pygments
+    except ImportError:
+        pygments = False
+
+    if not pygments:
+        print_blob_simple(fname)
+        return
+    else:
+        try:
+            print_blob_highlighted(fname)
+        except ValueError:
+            # pygments couldn't guess a lexer to highlight the code, try
+            # another method with sampling the file contents.
+            try:
+                print_blob_highlighted(fname, sample_code=True)
+            except ValueError:
+                # pygments really could not find any lexer for this file.
+                print_blob_simple(fname)
 
-	try:
-		import pygments
-	except ImportError:
-		pygments = False
-
-	if not pygments:
-		print_blob_simple(fname)
-		return
-	else:
-		try:
-			print_blob_highlighted(fname)
-		except ValueError:
-			# pygments couldn't guess a lexer to highlight the code, try
-			# another method with sampling the file contents.
-			try:
-				print_blob_highlighted(fname, sample_code=True)
-			except ValueError:
-				# pygments really could not find any lexer for this file.
-				print_blob_simple(fname)
 
 def print_blob_simple(fname):
-	print '<div class="page_body">'
+    print('<div class="page_body">')
 
-	f = open(realpath(fname), 'r')
-	count = 1
-	for l in f:
-		l = fixu8(escape(l))
-		if l and l[-1] == '\n':
-			l = l[:-1]
-		l = replace_tabs(l)
+    f = open(realpath(fname), "r", errors="backslashreplace")
+    count = 1
+    for l in f:
+        l = xmlescape(l)
+        if l and l[-1] == "\n":
+            l = l[:-1]
+        l = replace_tabs(l)
 
-		print """\
+        print(
+            """\
 <div class="pre">\
 <a id="l%(c)d" href="#l%(c)d" class="linenr">%(c)4d</a> %(l)s\
 </div>\
-		""" % {
-			'c': count,
-			'l': l
-		}
-		count += 1
-	print '</div>'
+		"""
+            % {"c": count, "l": l}
+        )
+        count += 1
+    print("</div>")
+
 
 def print_blob_highlighted(fname, sample_code=False):
-	import pygments
-	import pygments.lexers
-	import pygments.formatters
-
-	code = open(realpath(fname), 'r').read()
-	if sample_code:
-		lexer = pygments.lexers.guess_lexer(code[:200],
-				encoding=config.repoencoding[0])
-	else:
-		lexer = pygments.lexers.guess_lexer_for_filename(fname, code[:200],
-				encoding=config.repoencoding[0])
-
-	pygments_version = map(int, pygments.__version__.split('.'))
-	if pygments_version >= [0, 7]:
-		linenos_method = 'inline'
-	else:
-		linenos_method = True
-	formatter = pygments.formatters.HtmlFormatter(linenos=linenos_method,
-				cssclass='page_body', encoding='utf-8')
+    import pygments
+    import pygments.lexers
+    import pygments.formatters
+
+    code = open(realpath(fname), "r").read()
+    if sample_code:
+        lexer = pygments.lexers.guess_lexer(
+            code[:200], encoding=config.repoencoding[0]
+        )
+    else:
+        lexer = pygments.lexers.guess_lexer_for_filename(
+            fname, code[:200], encoding=config.repoencoding[0]
+        )
+
+    formatter = pygments.formatters.HtmlFormatter(
+        linenos="inline",
+        cssclass="page_body",
+    )
+
+    print(pygments.highlight(code, lexer, formatter))
 
-	print pygments.highlight(code, lexer, formatter)
 
 def print_annotate(ann, style):
-	print '<div class="page_body">'
-	if isbinary(ann.fname):
-		print """
+    print('<div class="page_body">')
+    if isbinary(ann.fname):
+        print(
+            """
 <i>This is a binary file and its contents will not be displayed.</i>
 </div>
 		"""
-		return
+        )
+        return
 
-	if style == 'shade':
-		# here's the idea: we will assign to each patch a shade of
-		# color from its date (newer gets darker)
-		max = 0xff
-		min = max - 80
-
-		# to do that, we need to get a list of the patch hashes
-		# ordered by their dates
-		l = [ (date, hash) for (hash, date) in ann.patches.items() ]
-		l.sort()
-		l = [ hash for (date, hash) in l ]
-
-		# now we have to map each element to a number in the range
-		# min-max, with max being close to l[0] and min l[len(l) - 1]
-		lenn = max - min
-		lenl = len(l)
-		shadetable = {}
-		for i in range(0, lenl):
-			hash = l[i]
-			n = float(i * lenn) / lenl
-			n = max - int(round(n))
-			shadetable[hash] = n
-	elif style == "zebra":
-		lineclass = 'dark'
-
-	count = 1
-	prevhash = None
-	for l in ann.lines:
-		text = escape(l.text)
-		text = text.rstrip()
-		text = replace_tabs(text)
-		plongdate = time.strftime("%Y-%m-%d %H:%M:%S", l.pdate)
-		title = "%s by %s" % (plongdate, escape(l.pauthor) )
-
-		link = "%(myrname)s;a=commit;h=%(hash)s" % {
-			'myrname': config.myreponame,
-			'hash': l.phash
-		}
-
-		if style == "shade":
-			linestyle = 'style="background-color:#ffff%.2x"' % \
-					shadetable[l.phash]
-			lineclass = ''
-		elif style == "zebra":
-			linestyle = ''
-			if l.phash != prevhash:
-				if lineclass == 'dark':
-					lineclass = 'light'
-				else:
-					lineclass = 'dark'
-		else:
-			linestyle = ''
-			lineclass = ''
-
-		if l.phash != prevhash:
-			pdate = time.strftime("%Y-%m-%d", l.pdate)
-
-			left = l.pauthor.find('<')
-			right = l.pauthor.find('@')
-			if left != -1 and right != -1:
-				shortau = l.pauthor[left + 1:right]
-			elif l.pauthor.find(" ") != -1:
-				shortau = l.pauthor[:l.pauthor.find(" ")]
-			elif right != -1:
-				shortau = l.pauthor[:right]
-			else:
-				shortau = l.pauthor
-
-			desc = "%12.12s" % shortau
-			date = "%-10.10s" % pdate
-			prevhash = l.phash
-			line = 1
-		else:
-			if line == 1 and style in ["shade", "zebra"]:
-				t = "%s  " % time.strftime("%H:%M:%S", l.pdate)
-				desc = "%12.12s" % "'"
-				date = "%-10.10s" % t
-			else:
-				desc = "%12.12s" % "'"
-				date = "%-10.10s" % ""
-			line += 1
+    if style == "shade":
+        # here's the idea: we will assign to each patch a shade of
+        # color from its date (newer gets darker)
+        max = 0xFF
+        min = max - 80
+
+        # to do that, we need to get a list of the patch hashes
+        # ordered by their dates
+        l = [(date, hash) for (hash, date) in ann.patches.items()]
+        l.sort()
+        l = [hash for (date, hash) in l]
+
+        # now we have to map each element to a number in the range
+        # min-max, with max being close to l[0] and min l[len(l) - 1]
+        lenn = max - min
+        lenl = len(l)
+        shadetable = {}
+        for i in range(0, lenl):
+            hash = l[i]
+            n = float(i * lenn) / lenl
+            n = max - int(round(n))
+            shadetable[hash] = n
+    elif style == "zebra":
+        lineclass = "dark"
+
+    count = 1
+    prevhash = None
+    for l in ann.lines:
+        text = xmlescape(l.text)
+        text = text.rstrip()
+        text = replace_tabs(text)
+        plongdate = time.strftime("%Y-%m-%d %H:%M:%S", l.pdate)
+        title = "%s by %s" % (plongdate, xmlescape(l.pauthor))
+
+        link = "%(myrname)s;a=commit;h=%(hash)s" % {
+            "myrname": config.myreponame,
+            "hash": l.phash,
+        }
+
+        if style == "shade":
+            linestyle = (
+                'style="background-color:#ffff%.2x"' % shadetable[l.phash]
+            )
+            lineclass = ""
+        elif style == "zebra":
+            linestyle = ""
+            if l.phash != prevhash:
+                if lineclass == "dark":
+                    lineclass = "light"
+                else:
+                    lineclass = "dark"
+        else:
+            linestyle = ""
+            lineclass = ""
+
+        if l.phash != prevhash:
+            pdate = time.strftime("%Y-%m-%d", l.pdate)
+
+            left = l.pauthor.find("<")
+            right = l.pauthor.find("@")
+            if left != -1 and right != -1:
+                shortau = l.pauthor[left + 1 : right]
+            elif l.pauthor.find(" ") != -1:
+                shortau = l.pauthor[: l.pauthor.find(" ")]
+            elif right != -1:
+                shortau = l.pauthor[:right]
+            else:
+                shortau = l.pauthor
+
+            desc = "%12.12s" % shortau
+            date = "%-10.10s" % pdate
+            prevhash = l.phash
+            line = 1
+        else:
+            if line == 1 and style in ["shade", "zebra"]:
+                t = "%s  " % time.strftime("%H:%M:%S", l.pdate)
+                desc = "%12.12s" % "'"
+                date = "%-10.10s" % t
+            else:
+                desc = "%12.12s" % "'"
+                date = "%-10.10s" % ""
+            line += 1
 
-		print """\
+        print(
+            """\
 <div class="pre %(class)s" %(style)s>\
 <a href="%(link)s" title="%(title)s" class="annotate_desc">%(date)s %(desc)s</a> \
 <a href="%(link)s" title="%(title)s" class="linenr">%(c)4d</a> \
 <a href="%(link)s" title="%(title)s" class="line">%(text)s</a>\
 </div>\
-		""" % {
-			'class': lineclass,
-			'style': linestyle,
-			'date': date,
-			'desc': escape(desc),
-			'c': count,
-			'text': text,
-			'title': title,
-			'link': link
-		}
+		"""
+            % {
+                "class": lineclass,
+                "style": linestyle,
+                "date": date,
+                "desc": xmlescape(desc),
+                "c": count,
+                "text": text,
+                "title": title,
+                "link": link,
+            }
+        )
 
-		count += 1
+        count += 1
 
-	print '</div>'
+    print("</div>")
 
 
 #
 # available actions
 #
 
-def do_summary():
-	print_header()
-	print_navbar()
-	owner = repo_get_owner()
-
-	# we should optimize this, it's a pity to go in such a mess for just
-	# one hash
-	ps = get_last_patches(1)
-
-	print '<div class="title">&nbsp;</div>'
-	print '<table cellspacing="0">'
-	print '  <tr><td>description</td><td>%s</td></tr>' % \
-			escape(config.repodesc)
-	if owner:
-		print '  <tr><td>owner</td><td>%s</td></tr>' % escape(owner)
-	if len(ps) > 0:
-		print '  <tr><td>last change</td><td>%s</td></tr>' % \
-			ps[0].local_date_str
-	print '  <tr><td>url</td><td><a href="%(url)s">%(url)s</a></td></tr>' %\
-			{ 'url': config.repourl }
-	if config.repoprojurl:
-		print '  <tr><td>project url</td>'
-		print '  <td><a href="%(url)s">%(url)s</a></td></tr>' % \
-			{ 'url': config.repoprojurl }
-	print '</table>'
 
-	print_shortlog(15)
-	print_footer()
+def do_summary():
+    print_header()
+    print_navbar()
+    owner = repo_get_owner()
+
+    # we should optimize this, it's a pity to go in such a mess for just
+    # one hash
+    ps = get_last_patches(1)
+
+    print('<div class="title">&nbsp;</div>')
+    print('<table cellspacing="0">')
+    print(
+        "  <tr><td>description</td><td>%s</td></tr>"
+        % xmlescape(config.repodesc)
+    )
+    if owner:
+        print("  <tr><td>owner</td><td>%s</td></tr>" % xmlescape(owner))
+    if len(ps) > 0:
+        print(
+            "  <tr><td>last change</td><td>%s</td></tr>" % ps[0].local_date_str
+        )
+    print(
+        '  <tr><td>url</td><td><a href="%(url)s">%(url)s</a></td></tr>'
+        % {"url": config.repourl}
+    )
+    if config.repoprojurl:
+        print("  <tr><td>project url</td>")
+        print(
+            '  <td><a href="%(url)s">%(url)s</a></td></tr>'
+            % {"url": config.repoprojurl}
+        )
+    print("</table>")
+
+    print_shortlog(15)
+    print_readme()
+    print_footer()
 
 
 def do_commitdiff(phash):
-	print_header()
-	print_navbar(h = phash)
-	p = get_patch(phash)
-	print """
+    print_header()
+    print_navbar(h=phash)
+    p = get_patch(phash)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">%(name)s</a>
 </div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-	}
-
-	dsrc = p.getdiff()
-	print_diff(dsrc)
-	print_footer()
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+        }
+    )
+
+    dsrc = p.getdiff()
+    print_diff(dsrc)
+    print_footer()
+
 
 def do_plain_commitdiff(phash):
-	print_plain_header()
-	dsrc = get_diff(phash)
-	for l in dsrc:
-		sys.stdout.write(fixu8(l))
+    print_plain_header()
+    dsrc = get_diff(phash)
+    for l in dsrc:
+        sys.stdout.write((l))
+
 
 def do_darcs_commitdiff(phash):
-	print_header()
-	print_navbar(h = phash)
-	p = get_patch(phash)
-	print """
+    print_header()
+    print_navbar(h=phash)
+    p = get_patch(phash)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">%(name)s</a>
 </div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-	}
-
-	dsrc = get_darcs_diff(phash)
-	print_darcs_diff(dsrc)
-	print_footer()
-
-def do_raw_commitdiff(phash):
-	print_plain_header()
-	dsrc = get_raw_diff(phash)
-	if not dsrc:
-		print "Error opening file!"
-		return
-	for l in dsrc:
-		sys.stdout.write(l)
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+        }
+    )
+
+    dsrc = get_darcs_diff(phash)
+    print_darcs_diff(dsrc)
+    print_footer()
 
 
 def do_headdiff(phash):
-	print_header()
-	print_navbar(h = phash)
-	p = get_patch(phash)
-	print """
+    print_header()
+    print_navbar(h=phash)
+    p = get_patch(phash)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">
     %(name)s --&gt; to head</a>
 </div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-	}
-
-	dsrc = get_patch_headdiff(phash)
-	print_diff(dsrc)
-	print_footer()
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+        }
+    )
+
+    dsrc = get_patch_headdiff(phash)
+    print_diff(dsrc)
+    print_footer()
+
 
 def do_plain_headdiff(phash):
-	print_plain_header()
-	dsrc = get_patch_headdiff(phash)
-	for l in dsrc:
-		sys.stdout.write(fixu8(l))
+    print_plain_header()
+    dsrc = get_patch_headdiff(phash)
+    for l in dsrc:
+        sys.stdout.write((l))
+
 
 def do_darcs_headdiff(phash):
-	print_header()
-	print_navbar(h = phash)
-	p = get_patch(phash)
-	print """
+    print_header()
+    print_navbar(h=phash)
+    p = get_patch(phash)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">
     %(name)s --&gt; to head</a>
 </div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-	}
-
-	dsrc = get_darcs_headdiff(phash)
-	print_darcs_diff(dsrc)
-	print_footer()
-
-def do_raw_headdiff(phash):
-	print_plain_header()
-	dsrc = get_darcs_headdiff(phash)
-	for l in dsrc:
-		sys.stdout.write(l)
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+        }
+    )
+
+    dsrc = get_darcs_headdiff(phash)
+    print_darcs_diff(dsrc)
+    print_footer()
 
 
 def do_filediff(phash, fname):
-	print_header()
-	print_navbar(h = phash, f = fname)
-	p = get_patch(phash)
-	dsrc = get_file_diff(phash, fname)
-	print """
+    print_header()
+    print_navbar(h=phash, f=fname)
+    p = get_patch(phash)
+    dsrc = get_file_diff(phash, fname)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">%(name)s</a>
 </div>
 <div class="page_path"><b>%(fname)s</b></div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-		'fname': escape(fname),
-	}
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+            "fname": xmlescape(fname),
+        }
+    )
+
+    print_diff(dsrc)
+    print_footer()
 
-	print_diff(dsrc)
-	print_footer()
 
 def do_plain_filediff(phash, fname):
-	print_plain_header()
-	dsrc = get_file_diff(phash, fname)
-	for l in dsrc:
-		sys.stdout.write(fixu8(l))
+    print_plain_header()
+    dsrc = get_file_diff(phash, fname)
+    for l in dsrc:
+        sys.stdout.write((l))
+
 
 def do_darcs_filediff(phash, fname):
-	print_header()
-	print_navbar(h = phash, f = fname)
-	p = get_patch(phash)
-	print """
+    print_header()
+    print_navbar(h=phash, f=fname)
+    p = get_patch(phash)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">%(name)s</a>
 </div>
 <div class="page_path"><b>%(fname)s</b></div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-		'fname': escape(fname),
-	}
-
-	dsrc = get_darcs_diff(phash, fname)
-	print_darcs_diff(dsrc)
-	print_footer()
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+            "fname": xmlescape(fname),
+        }
+    )
+
+    dsrc = get_darcs_diff(phash, fname)
+    print_darcs_diff(dsrc)
+    print_footer()
 
 
 def do_file_headdiff(phash, fname):
-	print_header()
-	print_navbar(h = phash, f = fname)
-	p = get_patch(phash)
-	dsrc = get_file_headdiff(phash, fname)
-	print """
+    print_header()
+    print_navbar(h=phash, f=fname)
+    p = get_patch(phash)
+    dsrc = get_file_headdiff(phash, fname)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">
     %(name)s --&gt; to head</a>
 </div>
 <div class="page_path"><b>%(fname)s</b></div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-		'fname': escape(fname),
-	}
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+            "fname": xmlescape(fname),
+        }
+    )
+
+    print_diff(dsrc)
+    print_footer()
 
-	print_diff(dsrc)
-	print_footer()
 
 def do_plain_fileheaddiff(phash, fname):
-	print_plain_header()
-	dsrc = get_file_headdiff(phash, fname)
-	for l in dsrc:
-		sys.stdout.write(fixu8(l))
+    print_plain_header()
+    dsrc = get_file_headdiff(phash, fname)
+    for l in dsrc:
+        sys.stdout.write((l))
+
 
 def do_darcs_fileheaddiff(phash, fname):
-	print_header()
-	print_navbar(h = phash, f = fname)
-	p = get_patch(phash)
-	print """
+    print_header()
+    print_navbar(h=phash, f=fname)
+    p = get_patch(phash)
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">
     %(name)s --&gt; to head</a>
 </div>
 <div class="page_path"><b>%(fname)s</b></div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': p.hash,
-		'name': escape(p.name),
-		'fname': escape(fname),
-	}
-
-	dsrc = get_darcs_headdiff(phash, fname)
-	print_darcs_diff(dsrc)
-	print_footer()
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+            "fname": xmlescape(fname),
+        }
+    )
+
+    dsrc = get_darcs_headdiff(phash, fname)
+    print_darcs_diff(dsrc)
+    print_footer()
 
-	print_plain_header()
-	print "Not yet implemented"
+    print_plain_header()
+    print("Not yet implemented")
 
 
 def do_commit(phash):
-	print_header()
-	print_navbar(h = phash)
-	p = get_patch(phash)
+    print_header()
+    print_navbar(h=phash)
+    p = get_patch(phash)
 
-	print """
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commitdiff;h=%(hash)s">%(name)s</a>
 </div>
